| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
Gaudi::Functional::details::insert_t Struct Reference

`#include <GaudiAlg/FunctionalDetails.h>`

## Public Types
template<typename Container >
using | c_remove_ptr_t = typename std::remove_pointer< typename Container::value_type >::type

## Public Member Functions
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.push_back(v))
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.insert(v))
template<typename Container , typename = typename std::enable_if< std::is_pointer<typename Container::value_type>::value >::type>
auto | operator() (Container &c, c_remove_ptr_t< Container > &&v) const
template<typename Container , typename Value >
void | operator() (Container &c, boost::optional< Value > &&v) const

## Detailed Description

Definition at line 107 of file FunctionalDetails.h.

## Member Typedef Documentation

template<typename Container >

using Gaudi::Functional::details::insert_t::c_remove_ptr_t = typename std::remove_pointer<typename Container::value_type>::type

Definition at line 110 of file FunctionalDetails.h.

## Member Function Documentation

template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.push_back(v) )
| inline

Definition at line 113 of file FunctionalDetails.h.

113 { return c.push_back( std::forward<Value>(v) ); }
gaudirun.c
c
Definition: gaudirun.py:391
template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.insert(v) )
| inline

Definition at line 116 of file FunctionalDetails.h.

116 { return c.insert( std::forward<Value>(v) ); }
gaudirun.c
c
Definition: gaudirun.py:391
template<typename Container , typename = typename std::enable_if< std::is_pointer<typename Container::value_type>::value >::type>

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | c_remove_ptr_t< Container > && | v
| ) |  | const
| inline

Definition at line 120 of file FunctionalDetails.h.

121 { return operator()( c, new c_remove_ptr_t<Container>{ std::move(v) } ); }
gaudirun.c
c
Definition: gaudirun.py:391
std::move
T move(T...args)
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:113
template<typename Container , typename Value >

void Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | boost::optional< Value > && | v
| ) |  | const
| inline

Definition at line 124 of file FunctionalDetails.h.

124 { if (v) operator()(c,std::move(*v)); }
gaudirun.c
c
Definition: gaudirun.py:391
std::move
T move(T...args)
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:113

The documentation for this struct was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h